#include <stdio.h>

#include "plugin_shared.h"
#include "plugin_exec.h"

int load_shared (char* plugin_name)
{
   SharedPluginControler* SPC;
   SPC = new SharedPluginControler (plugin_name);

   printf("Try to run the Plugin\n");
   if(SPC->getPlugin()) {
     SPC->getPlugin()->run(10);
   } 
   delete SPC;
}

int load_exec (char* plugin_file)
{
   ExecPluginControler* SPC;
   SPC = new ExecPluginControler (plugin_file);
   
   printf("Try to run the Plugin\n");
   if(SPC->getPlugin()) {
      SPC->getPlugin()->run(10);
   } 
   
   delete SPC;
}


int main (void)
{
   printf("\n******************************************************\n");
   printf("Trying to load a shared library\n");
   printf("******************************************************\n");
   load_shared("./example.shared");
 
   printf("\n******************************************************\n");
   printf("Trying to load a application designed to communicate\n");
   printf("******************************************************\n");
   load_exec("./example.exec");
   return 0;
}
