#include <stdio.h>
#include <glib.h>

#include <sys/types.h>
#include <sys/ipc.h>
#include <sys/shm.h>

#include "plugin_exec.h"

#define  SHMKEY 100
#define  SHMKEY_STRING "100"

ExecPlugin::ExecPlugin(void) {
   printf("+ ExecPlugin\n");
}

ExecPlugin::~ExecPlugin(void) {
   printf("~ ExecPlugin\n");
}

ExecPluginControler::ExecPluginControler (char* plugin_file)
: PluginControler()
{
   printf("+ ExecPluginControler\n");
   
   int shmid;
   int ret;
   
	  fflush(stdout);
   // execl("./example.exec","example.exec","-plugin",SHMKEY_STRING,NULL);
   ret = system("./example.exec -plugin " SHMKEY_STRING);
   if(ret == -1 || ret == 127)
     g_error("system call failed.\n");
   
   shmid = shmget((key_t)SHMKEY,0,0);
   if(shmid == -1)
     g_error("Can't get the shared memory.\n");
   
   plugin  = (Plugin*) shmat(shmid,NULL,0);
   if(plugin == (Plugin*)-1)
     g_error("Can't attach the plugin.\n");
}

Plugin* ExecPluginControler::getPlugin()
{
   void* a = (void*) plugin;
   // return plugin;
   return new ExecPlugin((ExecPlugin&)*plugin);
}


ExecPluginControler::~ExecPluginControler ()
{
   printf("~ ExecPluginControler\n");
   
   if(shmdt(plugin) == -1)
     g_error("Can't destroy shared memory.\n");
}

