#include <stdio.h>
#include <glib.h>
#include <dlfcn.h>

#include "plugin_shared.h"

const char* plugin_loader_function = "plugin_loader";

SharedPlugin::SharedPlugin(void) {
   printf("+ SharedPlugin\n");
}

SharedPlugin::~SharedPlugin(void) {
   printf("~ SharedPlugin\n");
}


SharedPluginControler::SharedPluginControler(char* plugin_file)
: PluginControler()
{
   printf("+ SharedPluginControler\n");

   printf("Opening shared library '%s': ",plugin_file); fflush(stdout);
   plugin_handler =  dlopen (plugin_file, PLUGIN_OPEN_MODE);
   
   if (!plugin_handler) {
      printf("Failed.\n");
      g_error(dlerror());
   }
   else {
      printf("Sucess.\n");
   }
    
   printf("Looking for the '%s' function : ",plugin_loader_function); fflush(stdout);
   plugin_loader_ptr loader = (plugin_loader_ptr)dlsym(plugin_handler,plugin_loader_function);
   
   if (dlerror() != NULL) {
      printf("Failed.\n");
      g_error(dlerror());
   }
   else {
      printf("Sucess.\n");
   }
   
   printf("Launching the class creator\n"); fflush(stdout);
   shared_plugin = NULL;
   shared_plugin = (*loader)();
   
   if(!shared_plugin) {
      g_error("Creation Failed.\n");      
   }
   else {
      printf("Creation Sucess.\n");
   }
}

Plugin* SharedPluginControler::getPlugin()
{
   return shared_plugin;
}

SharedPluginControler::~SharedPluginControler()
{
   printf("~ SharedPluginControler\n");
   if(shared_plugin) {
      delete shared_plugin;
   }
   else {
      g_warning("You delete a plugin controled by a plugin controler\n");
   }
   dlclose(plugin_handler);
}
