#ifndef PLUGIN_SHARED
#define PLUGIN_SHARED

#include "plugin.h"

#ifdef RTLD_NOW
#define PLUGIN_OPEN_MODE	RTLD_NOW /* RTLD_LAZY RTLD_GLOBAL */
#else if
#define PLUGIN_OPEN_MODE	0
#endif

class Plugin;

extern const char* plugin_loader_function;
typedef Plugin* (*plugin_loader_ptr) (void);

class SharedPlugin : public Plugin
{
 public:
   SharedPlugin(void);
   ~SharedPlugin();
   
   virtual void run (int number) = 0;
};

class SharedPluginControler : public PluginControler
{
 protected:
   void*   plugin_handler;
   Plugin* shared_plugin;
   
 public:
   SharedPluginControler(char* name);
   ~SharedPluginControler();
 
   Plugin* getPlugin();
};

#endif
